Index: sbin/instps/ps.h
===================================================================
RCS file: sbin/instps/ps.h
diff -N sbin/instps/ps.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sbin/instps/ps.h	12 Feb 2009 14:38:06 -0000	1.1.2.1
@@ -0,0 +1,89 @@
+/*	$OpenBSD: ps.h,v 1.7 2006/10/16 15:00:10 millert Exp $	*/
+/*	$NetBSD: ps.h,v 1.11 1995/09/29 21:57:03 cgd Exp $	*/
+
+/*-
+ * Copyright (c) 1990, 1993
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ *	@(#)ps.h	8.1 (Berkeley) 5/31/93
+ */
+
+#define	UNLIMITED	0	/* unlimited terminal width */
+enum type {
+	INT8, UINT8, INT16, UINT16, INT32, UINT32, INT64, UINT64
+};
+
+struct usave {
+	struct	timeval u_start;
+	struct	rusage u_ru;
+	struct	rusage u_cru;
+	char	u_acflag;
+	char	u_valid;
+};
+
+/* Variables. */
+typedef struct varent {
+	struct varent *next;
+	struct var *var;
+} VARENT;
+
+struct kinfo_proc2;
+typedef struct var {
+	char	*name;		/* name(s) of variable */
+	char	*header;	/* default header */
+	char	*alias;		/* aliases */
+#define	COMM	0x01		/* needs exec arguments and environment (XXX) */
+#define	LJUST	0x02		/* left adjust on output (trailing blanks) */
+#define	USER	0x04		/* needs user structure */
+#define	INF127	0x08		/* 127 = infinity: if > 127, print 127. */
+#define	NLIST	0x10		/* needs nlist info from kernel */
+	u_int	flag;
+				/* output routine */
+	void	(*oproc)(const struct kinfo_proc2 *, struct varent *);
+	short	width;		/* printing width */
+	char	parsed;		/* have we been parsed yet? (avoid dupes) */
+	/*
+	 * The following (optional) elements are hooks for passing information
+	 * to the generic output routines: pvar, evar, uvar (those which print
+	 * simple elements from well known structures: proc, eproc, usave)
+	 */
+	int	off;		/* offset in structure */
+	enum	type type;	/* type of element */
+	char	*fmt;		/* printf format */
+	char	*time;		/* time format */
+	/*
+	 * glue to link selected fields together
+	 */
+} VAR;
+
+#ifdef __LP64__
+#define	PTRWIDTH	16
+#else
+#define	PTRWIDTH	8
+#endif
+
+#include "extern.h"
Index: share/man/man9/Makefile
===================================================================
RCS file: /cvs/OpenBSD/src/share/man/man9/Makefile,v
retrieving revision 1.143
retrieving revision 1.143.4.3
diff -u -r1.143 -r1.143.4.3
--- share/man/man9/Makefile	23 Jul 2008 11:45:21 -0000	1.143
+++ share/man/man9/Makefile	18 Feb 2009 18:20:19 -0000	1.143.4.3
@@ -9,8 +9,10 @@
 	disk.9 disklabel.9 dohooks.9 dopowerhooks.9 \
 	domountroothooks.9 doshutdownhooks.9 dostartuphooks.9 \
 	evcount.9 file.9 \
-	fork1.9 extent.9 getdevvp.9 getnewvnode.9 hash.9 hashinit.9 \
+	fork1.9 forkinst1.9 \
+	extent.9 getdevvp.9 getnewvnode.9 hash.9 hashinit.9 \
 	hardclock.9 hook_establish.9 hz.9 hzto.9 idgen32.9 \
+	inst.9 \
 	ieee80211.9 ieee80211_crypto.9 ieee80211_input.9 ieee80211_ioctl.9 \
 	ieee80211_node.9 ieee80211_output.9 ieee80211_proto.9 \
 	ieee80211_radiotap.9 \
@@ -175,6 +177,12 @@
 MLINKS+=iic.9 iic_acquire_bus.9 iic.9 iic_release_bus.9 iic.9 iic_exec.9 \
 	iic.9 iic_smbus_write_byte.9 iic.9 iic_smbus_read_byte.9 \
 	iic.9 iic_smbus_receive_byte.9
+MLINKS+=inst.9 instpnew.9 \
+	inst.9 instknew.9 \
+	inst.9 instpfind.9 \
+	inst.9 instkfind.9 \
+	inst.9 insthold.9 \
+	inst.9 instfree.9
 MLINKS+=kern.9 imax.9 kern.9 imin.9 kern.9 lmax.9 kern.9 lmin.9 \
 	kern.9 max.9 kern.9 min.9 kern.9 ulmax.9 kern.9 ulmin.9 kern.9 abs.9 \
 	kern.9 assert.9 kern.9 KASSERT.9 kern.9 KDASSERT.9 \
Index: sys/arch/amd64/amd64/db_disasm.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/arch/amd64/amd64/db_disasm.c,v
retrieving revision 1.8
retrieving revision 1.8.6.1
diff -u -r1.8 -r1.8.6.1
--- sys/arch/amd64/amd64/db_disasm.c	5 Nov 2007 19:23:24 -0000	1.8
+++ sys/arch/amd64/amd64/db_disasm.c	17 Sep 2008 13:37:32 -0000	1.8.6.1
@@ -94,7 +94,7 @@
 #define	Ril	36			/* long register in instruction */
 #define	Iba	37			/* byte immediate, don't print if 0xa */
 
-struct inst {
+struct dinst {
 	char *	i_name;			/* name */
 	short	i_has_modrm;		/* has regmodrm byte */
 	short	i_size;			/* operand size */
@@ -144,7 +144,7 @@
 	"xcrypt-cfb",	"xcrypt-ofb",	"",		""
 };
 
-struct inst db_inst_0f0x[] = {
+struct dinst db_inst_0f0x[] = {
 /*00*/	{ "",	   TRUE,  NONE,  op1(Ew),     db_Grp6 },
 /*01*/	{ "",	   TRUE,  NONE,  op1(Ew),     db_Grp7 },
 /*02*/	{ "lar",   TRUE,  LONG,  op2(E,R),    0 },
@@ -164,7 +164,7 @@
 /*0f*/	{ "",      FALSE, NONE,  0,	      0 },
 };
 
-struct inst	db_inst_0f2x[] = {
+struct dinst	db_inst_0f2x[] = {
 /*20*/	{ "mov",   TRUE,  LONG,  op2(CR,E),   0 }, /* use E for reg */
 /*21*/	{ "mov",   TRUE,  LONG,  op2(DR,E),   0 }, /* since mod == 11 */
 /*22*/	{ "mov",   TRUE,  LONG,  op2(E,CR),   0 },
@@ -184,7 +184,7 @@
 /*2f*/	{ "",      FALSE, NONE,  0,	      0 },
 };
 
-struct inst	db_inst_0f3x[] = {
+struct dinst	db_inst_0f3x[] = {
 /*30*/	{ "wrmsr", FALSE, NONE,  0,           0 },
 /*31*/	{ "rdtsc", FALSE, NONE,  0,           0 },
 /*32*/	{ "rdmsr", FALSE, NONE,  0,           0 },
@@ -204,7 +204,7 @@
 /*3f*/	{ "",      FALSE, NONE,  0,           0 },
 };
 
-struct inst	db_inst_0f8x[] = {
+struct dinst	db_inst_0f8x[] = {
 /*80*/	{ "jo",    FALSE, NONE,  op1(Dl),     0 },
 /*81*/	{ "jno",   FALSE, NONE,  op1(Dl),     0 },
 /*82*/	{ "jb",    FALSE, NONE,  op1(Dl),     0 },
@@ -224,7 +224,7 @@
 /*8f*/	{ "jnle",  FALSE, NONE,  op1(Dl),     0 },
 };
 
-struct inst	db_inst_0f9x[] = {
+struct dinst	db_inst_0f9x[] = {
 /*90*/	{ "seto",  TRUE,  NONE,  op1(Eb),     0 },
 /*91*/	{ "setno", TRUE,  NONE,  op1(Eb),     0 },
 /*92*/	{ "setb",  TRUE,  NONE,  op1(Eb),     0 },
@@ -244,7 +244,7 @@
 /*9f*/	{ "setnle",TRUE,  NONE,  op1(Eb),     0 },
 };
 
-struct inst	db_inst_0fax[] = {
+struct dinst	db_inst_0fax[] = {
 /*a0*/	{ "push",  FALSE, QUAD,  op1(Si),     0 },
 /*a1*/	{ "pop",   FALSE, QUAD,  op1(Si),     0 },
 /*a2*/	{ "cpuid", FALSE, NONE,  0,	      0 },
@@ -264,7 +264,7 @@
 /*af*/	{ "imul",  TRUE,  LONG,  op2(E,R),    0 },
 };
 
-struct inst	db_inst_0fbx[] = {
+struct dinst	db_inst_0fbx[] = {
 /*b0*/	{ "cmpxchg",TRUE, BYTE,	 op2(R, E),   0 },
 /*b1*/	{ "cmpxchg",TRUE, LONG,	 op2(R, E),   0 },
 /*b2*/	{ "lss",   TRUE,  LONG,  op2(E, R),   0 },
@@ -284,7 +284,7 @@
 /*bf*/	{ "movsw", TRUE,  LONG,  op2(Ew, R),  0 },
 };
 
-struct inst	db_inst_0fcx[] = {
+struct dinst	db_inst_0fcx[] = {
 /*c0*/	{ "xadd",  TRUE,  BYTE,	 op2(R, E),   0 },
 /*c1*/	{ "xadd",  TRUE,  LONG,	 op2(R, E),   0 },
 /*c2*/	{ "",	   FALSE, NONE,	 0,	      0 },
@@ -304,7 +304,7 @@
 /*cf*/	{ "bswap", FALSE, LONG,  op1(Ril),    0 },
 };
 
-struct inst *db_inst_0f[] = {
+struct dinst *db_inst_0f[] = {
 	db_inst_0f0x,
 	NULL,
 	db_inst_0f2x,
@@ -479,7 +479,7 @@
 	"sar"
 };
 
-struct inst db_Grp3[] = {
+struct dinst db_Grp3[] = {
 	{ "test",  TRUE, NONE, op2(I,E), 0 },
 	{ "test",  TRUE, NONE, op2(I,E), 0 },
 	{ "not",   TRUE, NONE, op1(E),   0 },
@@ -490,7 +490,7 @@
 	{ "idiv",  TRUE, NONE, op2(E,A), 0 },
 };
 
-struct inst	db_Grp4[] = {
+struct dinst	db_Grp4[] = {
 	{ "inc",   TRUE, BYTE, op1(E),   0 },
 	{ "dec",   TRUE, BYTE, op1(E),   0 },
 	{ "",      TRUE, NONE, 0,	 0 },
@@ -501,7 +501,7 @@
 	{ "",      TRUE, NONE, 0,	 0 }
 };
 
-struct inst	db_Grp5[] = {
+struct dinst	db_Grp5[] = {
 	{ "inc",   TRUE, LONG, op1(E),   0 },
 	{ "dec",   TRUE, LONG, op1(E),   0 },
 	{ "call",  TRUE, QUAD, op1(Eind),0 },
@@ -512,7 +512,7 @@
 	{ "",      TRUE, NONE, 0,	 0 }
 };
 
-struct inst db_inst_table[256] = {
+struct dinst db_inst_table[256] = {
 /*00*/	{ "add",   TRUE,  BYTE,  op2(R, E),  0 },
 /*01*/	{ "add",   TRUE,  LONG,  op2(R, E),  0 },
 /*02*/	{ "add",   TRUE,  BYTE,  op2(E, R),  0 },
@@ -802,7 +802,7 @@
 /*ff*/	{ "",	   TRUE,  NONE,  0,	     db_Grp5 },
 };
 
-struct inst	db_bad_inst =
+struct dinst	db_bad_inst =
 	{ "???",   FALSE, NONE,  0,	      0 }
 ;
 
@@ -1076,7 +1076,7 @@
 	int	size;
 	int	short_addr;
 	char *	seg;
-	struct inst *	ip;
+	struct dinst *	ip;
 	char *	i_name;
 	int	i_size;
 	int	i_mode;
@@ -1208,12 +1208,12 @@
 	    ip->i_extra == db_GrpA || ip->i_extra == db_GrpB) {
 		i_name = ((char **)ip->i_extra)[f_reg(regmodrm, 0)];
 	} else if (ip->i_extra == db_Grp3) {
-		ip = (struct inst *)ip->i_extra;
+		ip = (struct dinst *)ip->i_extra;
 		ip = &ip[f_reg(regmodrm, 0)];
 		i_name = ip->i_name;
 		i_mode = ip->i_mode;
 	} else if (ip->i_extra == db_Grp4 || ip->i_extra == db_Grp5) {
-		ip = (struct inst *)ip->i_extra;
+		ip = (struct dinst *)ip->i_extra;
 		ip = &ip[f_reg(regmodrm, 0)];
 		i_name = ip->i_name;
 		i_mode = ip->i_mode;
Index: sys/arch/arm/arm/db_trace.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/arch/arm/arm/db_trace.c,v
retrieving revision 1.3
retrieving revision 1.3.10.1
diff -u -r1.3 -r1.3.10.1
--- sys/arch/arm/arm/db_trace.c	29 Nov 2006 12:24:17 -0000	1.3
+++ sys/arch/arm/arm/db_trace.c	16 Sep 2008 23:10:37 -0000	1.3.10.1
@@ -105,6 +105,9 @@
 		frame = (u_int32_t *)(DDB_REGS->tf_r11);
 	else {
 		if (trace_thread) {
+			/* FIXME: instances. */
+			(*pr) ("db_trace.c: operation not supported\n");
+#if 0
 			struct proc *p;
 			struct user *u;
 			(*pr) ("trace: pid %d ", (int)addr);
@@ -120,6 +123,7 @@
 			frame = (u_int32_t *)(u->u_pcb.pcb_un.un_32.pcb32_r11);
 #endif
 			(*pr)("at %p\n", frame);
+#endif
 		} else
 			frame = (u_int32_t *)(addr);
 	}
Index: sys/arch/i386/conf/GENERIC
===================================================================
RCS file: /cvs/OpenBSD/src/sys/arch/i386/conf/GENERIC,v
retrieving revision 1.633
retrieving revision 1.633.4.2
diff -u -r1.633 -r1.633.4.2
--- sys/arch/i386/conf/GENERIC	2 Aug 2008 16:09:29 -0000	1.633
+++ sys/arch/i386/conf/GENERIC	18 Feb 2009 12:43:24 -0000	1.633.4.2
@@ -15,6 +15,8 @@
 
 option		USER_PCICONF	# user-space PCI configuration
 
+makeoptions	DEBUG="-g"
+
 #option		VM86		# Virtual 8086 emulation
 option		KVM86		# Kernel Virtual 8086 emulation
 option		USER_LDT	# user-settable LDT; see i386_set_ldt(2)
@@ -30,7 +32,7 @@
 option		COMPAT_BSDOS	# binary compatibility with BSD/OS
 option		COMPAT_AOUT	# a.out binaries are emulated
 
-option		PROCFS		# /proc
+#option		PROCFS		# /proc
 #option		NTFS		# Experimental NTFS support
 
 # or use		root on nfs swap on nfs
Index: sys/arch/i386/i386/db_disasm.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/arch/i386/i386/db_disasm.c,v
retrieving revision 1.15
retrieving revision 1.15.6.1
diff -u -r1.15 -r1.15.6.1
--- sys/arch/i386/i386/db_disasm.c	1 Sep 2007 11:54:02 -0000	1.15
+++ sys/arch/i386/i386/db_disasm.c	12 Sep 2008 13:58:48 -0000	1.15.6.1
@@ -94,7 +94,7 @@
 #define	Ril	36			/* long register in instruction */
 #define	Iba	37			/* byte immediate, don't print if 0xa */
 
-struct inst {
+struct dinst {
 	char *	i_name;			/* name */
 	short	i_has_modrm;		/* has regmodrm byte */
 	short	i_size;			/* operand size */
@@ -149,7 +149,7 @@
 	"",		"",		"",		""
 };
 
-struct inst db_inst_0f0x[] = {
+struct dinst db_inst_0f0x[] = {
 /*00*/	{ "",	   TRUE,  NONE,  op1(Ew),     db_Grp6 },
 /*01*/	{ "",	   TRUE,  NONE,  op1(Ew),     db_Grp7 },
 /*02*/	{ "lar",   TRUE,  LONG,  op2(E,R),    0 },
@@ -169,7 +169,7 @@
 /*0f*/	{ "",      FALSE, NONE,  0,	      0 },
 };
 
-struct inst	db_inst_0f2x[] = {
+struct dinst	db_inst_0f2x[] = {
 /*20*/	{ "mov",   TRUE,  LONG,  op2(CR,E),   0 }, /* use E for reg */
 /*21*/	{ "mov",   TRUE,  LONG,  op2(DR,E),   0 }, /* since mod == 11 */
 /*22*/	{ "mov",   TRUE,  LONG,  op2(E,CR),   0 },
@@ -189,7 +189,7 @@
 /*2f*/	{ "",      FALSE, NONE,  0,	      0 },
 };
 
-struct inst	db_inst_0f3x[] = {
+struct dinst	db_inst_0f3x[] = {
 /*30*/	{ "wrmsr", FALSE, NONE,  0,           0 },
 /*31*/	{ "rdtsc", FALSE, NONE,  0,           0 },
 /*32*/	{ "rdmsr", FALSE, NONE,  0,           0 },
@@ -209,7 +209,7 @@
 /*3f*/	{ "",      FALSE, NONE,  0,           0 },
 };
 
-struct inst	db_inst_0f8x[] = {
+struct dinst	db_inst_0f8x[] = {
 /*80*/	{ "jo",    FALSE, NONE,  op1(Dl),     0 },
 /*81*/	{ "jno",   FALSE, NONE,  op1(Dl),     0 },
 /*82*/	{ "jb",    FALSE, NONE,  op1(Dl),     0 },
@@ -229,7 +229,7 @@
 /*8f*/	{ "jnle",  FALSE, NONE,  op1(Dl),     0 },
 };
 
-struct inst	db_inst_0f9x[] = {
+struct dinst	db_inst_0f9x[] = {
 /*90*/	{ "seto",  TRUE,  NONE,  op1(Eb),     0 },
 /*91*/	{ "setno", TRUE,  NONE,  op1(Eb),     0 },
 /*92*/	{ "setb",  TRUE,  NONE,  op1(Eb),     0 },
@@ -249,7 +249,7 @@
 /*9f*/	{ "setnle",TRUE,  NONE,  op1(Eb),     0 },
 };
 
-struct inst	db_inst_0fax[] = {
+struct dinst	db_inst_0fax[] = {
 /*a0*/	{ "push",  FALSE, NONE,  op1(Si),     0 },
 /*a1*/	{ "pop",   FALSE, NONE,  op1(Si),     0 },
 /*a2*/	{ "cpuid", FALSE, NONE,  0,	      0 },
@@ -269,7 +269,7 @@
 /*af*/	{ "imul",  TRUE,  LONG,  op2(E,R),    0 },
 };
 
-struct inst	db_inst_0fbx[] = {
+struct dinst	db_inst_0fbx[] = {
 /*b0*/	{ "cmpxchg",TRUE, BYTE,	 op2(R, E),   0 },
 /*b1*/	{ "cmpxchg",TRUE, LONG,	 op2(R, E),   0 },
 /*b2*/	{ "lss",   TRUE,  LONG,  op2(E, R),   0 },
@@ -289,7 +289,7 @@
 /*bf*/	{ "movsw", TRUE,  LONG,  op2(Ew, R),  0 },
 };
 
-struct inst	db_inst_0fcx[] = {
+struct dinst	db_inst_0fcx[] = {
 /*c0*/	{ "xadd",  TRUE,  BYTE,	 op2(R, E),   0 },
 /*c1*/	{ "xadd",  TRUE,  LONG,	 op2(R, E),   0 },
 /*c2*/	{ "",	   FALSE, NONE,	 0,	      0 },
@@ -309,7 +309,7 @@
 /*cf*/	{ "bswap", FALSE, LONG,  op1(Ril),    0 },
 };
 
-struct inst *db_inst_0f[] = {
+struct dinst *db_inst_0f[] = {
 	db_inst_0f0x,
 	NULL,
 	db_inst_0f2x,
@@ -484,7 +484,7 @@
 	"sar"
 };
 
-struct inst db_Grp3[] = {
+struct dinst db_Grp3[] = {
 	{ "test",  TRUE, NONE, op2(I,E), 0 },
 	{ "test",  TRUE, NONE, op2(I,E), 0 },
 	{ "not",   TRUE, NONE, op1(E),   0 },
@@ -495,7 +495,7 @@
 	{ "idiv",  TRUE, NONE, op2(E,A), 0 },
 };
 
-struct inst	db_Grp4[] = {
+struct dinst	db_Grp4[] = {
 	{ "inc",   TRUE, BYTE, op1(E),   0 },
 	{ "dec",   TRUE, BYTE, op1(E),   0 },
 	{ "",      TRUE, NONE, 0,	 0 },
@@ -506,7 +506,7 @@
 	{ "",      TRUE, NONE, 0,	 0 }
 };
 
-struct inst	db_Grp5[] = {
+struct dinst	db_Grp5[] = {
 	{ "inc",   TRUE, LONG, op1(E),   0 },
 	{ "dec",   TRUE, LONG, op1(E),   0 },
 	{ "call",  TRUE, NONE, op1(Eind),0 },
@@ -517,7 +517,7 @@
 	{ "",      TRUE, NONE, 0,	 0 }
 };
 
-struct inst db_inst_table[256] = {
+struct dinst db_inst_table[256] = {
 /*00*/	{ "add",   TRUE,  BYTE,  op2(R, E),  0 },
 /*01*/	{ "add",   TRUE,  LONG,  op2(R, E),  0 },
 /*02*/	{ "add",   TRUE,  BYTE,  op2(E, R),  0 },
@@ -807,7 +807,7 @@
 /*ff*/	{ "",	   TRUE,  NONE,  0,	     db_Grp5 },
 };
 
-struct inst	db_bad_inst =
+struct dinst	db_bad_inst =
 	{ "???",   FALSE, NONE,  0,	      0 }
 ;
 
@@ -1077,7 +1077,7 @@
 	int	size;
 	int	short_addr;
 	char *	seg;
-	struct inst *	ip;
+	struct dinst *	ip;
 	char *	i_name;
 	int	i_size;
 	int	i_mode;
@@ -1176,12 +1176,12 @@
 	    ip->i_extra == db_GrpC) {
 		i_name = ((char **)ip->i_extra)[f_reg(regmodrm)];
 	} else if (ip->i_extra == db_Grp3) {
-		ip = (struct inst *)ip->i_extra;
+		ip = (struct dinst *)ip->i_extra;
 		ip = &ip[f_reg(regmodrm)];
 		i_name = ip->i_name;
 		i_mode = ip->i_mode;
 	} else if (ip->i_extra == db_Grp4 || ip->i_extra == db_Grp5) {
-		ip = (struct inst *)ip->i_extra;
+		ip = (struct dinst *)ip->i_extra;
 		ip = &ip[f_reg(regmodrm)];
 		i_name = ip->i_name;
 		i_mode = ip->i_mode;
Index: sys/arch/i386/i386/db_trace.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/arch/i386/i386/db_trace.c,v
retrieving revision 1.13
retrieving revision 1.13.10.1
diff -u -r1.13 -r1.13.10.1
--- sys/arch/i386/i386/db_trace.c	28 Nov 2006 18:56:17 -0000	1.13
+++ sys/arch/i386/i386/db_trace.c	16 Sep 2008 23:10:38 -0000	1.13.10.1
@@ -215,6 +215,9 @@
 	} else if (trace_thread) {
 		(*pr) ("db_trace.c: can't trace thread\n");
 	} else if (trace_proc) {
+		/* FIXME: instances. */
+		(*pr) ("db_trace.c: operation not supported\n");
+#if 0
 		struct proc *p = pfind((pid_t)addr);
 		if (p == NULL) {
 			(*pr) ("db_trace.c: process not found\n");
@@ -223,6 +226,7 @@
 		frame = (struct i386_frame *)p->p_addr->u_pcb.pcb_ebp;
 		callpc = (db_addr_t)
 		    db_get_value((int)&frame->f_retaddr, 4, FALSE);
+#endif
 	} else {
 		frame = (struct i386_frame *)addr;
 		callpc = (db_addr_t)
Index: sys/arch/powerpc/powerpc/pmap.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/arch/powerpc/powerpc/pmap.c,v
retrieving revision 1.105
retrieving revision 1.105.4.1
diff -u -r1.105 -r1.105.4.1
--- sys/arch/powerpc/powerpc/pmap.c	14 Jun 2008 10:55:20 -0000	1.105
+++ sys/arch/powerpc/powerpc/pmap.c	16 Sep 2008 23:10:38 -0000	1.105.4.1
@@ -2578,8 +2578,11 @@
 }
 
 
+/* FIXME: is this even used? */
+#if 0
 /* debugger assist function */
 int pmap_prtrans(u_int pid, vaddr_t va);
+#endif
 
 void
 pmap_print_pted(struct pte_desc *pted, int(*print)(const char *, ...))
@@ -2649,6 +2652,8 @@
 	return 0;
 }
 
+/* FIXME: is this used anywhere? */
+#if 0
 int pmap_dump_pmap(u_int pid);
 int
 pmap_dump_pmap(u_int pid)
@@ -2675,7 +2680,10 @@
 
 	return 0;
 }
+#endif
 
+/* FIXME: is this even used? */
+#if 0
 int
 pmap_prtrans(u_int pid, vaddr_t va)
 {
@@ -2716,6 +2724,7 @@
 
 	return 0;
 }
+#endif
 int pmap_show_mappings(paddr_t pa);
 
 int
Index: sys/arch/sh/sh/db_interface.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/arch/sh/sh/db_interface.c,v
retrieving revision 1.2
retrieving revision 1.2.10.3
diff -u -r1.2 -r1.2.10.3
--- sys/arch/sh/sh/db_interface.c	6 Oct 2006 21:16:57 -0000	1.2
+++ sys/arch/sh/sh/db_interface.c	18 Feb 2009 12:43:24 -0000	1.2.10.3
@@ -367,11 +367,14 @@
 __db_procname_by_asid(int asid)
 {
 	static char notfound[] = "---";
+	struct inst *i;
 	struct proc *p;
 
-	LIST_FOREACH(p, &allproc, p_list) {
-		if (p->p_vmspace->vm_map.pmap->pm_asid == asid)
-			return (p->p_comm);
+	LIST_FOREACH(i, &inst_all, inst_list) {
+		LIST_FOREACH(p, &i->inst_proc->allproc, p_list) {
+			if (p->p_vmspace->vm_map.pmap->pm_asid == asid)
+				return (p->p_comm);
+		}
 	}
 
 	return (notfound);
@@ -601,6 +604,7 @@
 		  char *modif)
 {
 	struct proc *p;
+	struct inst *inst;
 	struct user *u;
 	struct pcb *pcb;
 	uint32_t *t32;
@@ -617,27 +621,29 @@
 		  "stack top    max used    frame top     max used"
 		  "  nest\n");
 
-	LIST_FOREACH(p, &allproc, p_list) {
-		u = p->p_addr;
-		pcb = &u->u_pcb;
-		/* stack */
-		t32 = (uint32_t *)(pcb->pcb_sf.sf_r7_bank - MAX_STACK);
-		for (i = 0; *t32++ == 0xa5a5a5a5; i++)
-			continue;
-		i = MAX_STACK - i * sizeof(int);
-
-		/* frame */
-		t8 = (uint8_t *)((vaddr_t)pcb + PAGE_SIZE - MAX_FRAME);
-		for (j = 0; *t8++ == 0x5a; j++)
-			continue;
-		j = MAX_FRAME - j;
-
-		db_printf("%6d 0x%08x %6d (%3d%%) 0x%08lx %6d (%3d%%) %d %s\n",
-		    p->p_lid,
-		    pcb->pcb_sf.sf_r7_bank, i, i * 100 / MAX_STACK,
-		    (vaddr_t)pcb + PAGE_SIZE, j, j * 100 / MAX_FRAME,
-		    j / sizeof(struct trapframe),
-		    p->p_comm);
+	LIST_FOREACH(inst, &inst_all, inst_list) {
+		LIST_FOREACH(p, &inst->inst_proc->allproc, p_list) {
+			u = p->p_addr;
+			pcb = &u->u_pcb;
+			/* stack */
+			t32 = (uint32_t *)(pcb->pcb_sf.sf_r7_bank - MAX_STACK);
+			for (i = 0; *t32++ == 0xa5a5a5a5; i++)
+				continue;
+			i = MAX_STACK - i * sizeof(int);
+	
+			/* frame */
+			t8 = (uint8_t *)((vaddr_t)pcb + PAGE_SIZE - MAX_FRAME);
+			for (j = 0; *t8++ == 0x5a; j++)
+				continue;
+			j = MAX_FRAME - j;
+	
+			db_printf("%6d 0x%08x %6d (%3d%%) 0x%08lx %6d (%3d%%) %d %s\n",
+			    p->p_lid,
+			    pcb->pcb_sf.sf_r7_bank, i, i * 100 / MAX_STACK,
+			    (vaddr_t)pcb + PAGE_SIZE, j, j * 100 / MAX_FRAME,
+			    j / sizeof(struct trapframe),
+			    p->p_comm);
+		}
 	}
 #undef	MAX_STACK
 #undef	MAX_FRAME
Index: sys/arch/sh/sh/pmap.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/arch/sh/sh/pmap.c,v
retrieving revision 1.9
retrieving revision 1.9.4.3
diff -u -r1.9 -r1.9.4.3
--- sys/arch/sh/sh/pmap.c	26 Jun 2008 05:42:13 -0000	1.9
+++ sys/arch/sh/sh/pmap.c	18 Feb 2009 12:43:24 -0000	1.9.4.3
@@ -1035,6 +1035,7 @@
 __pmap_asid_alloc()
 {
 	struct proc *p;
+	struct inst *i;
 	int i, j, k, n, map, asid;
 
 	/* Search free ASID */
@@ -1053,15 +1054,17 @@
 	}
 
 	/* Steal ASID */
-	LIST_FOREACH(p, &allproc, p_list) {
-		if ((asid = p->p_vmspace->vm_map.pmap->pm_asid) > 0) {
-			pmap_t pmap = p->p_vmspace->vm_map.pmap;
-			pmap->pm_asid = -1;
-			__pmap_asid.hint = asid;
-			/* Invalidate all old ASID entry */
-			sh_tlb_invalidate_asid(pmap->pm_asid);
-
-			return (__pmap_asid.hint);
+	LIST_FOREACH(inst, &inst_all, inst_list) {
+		LIST_FOREACH(p, &inst->inst_proc->allproc, p_list) {
+			if ((asid = p->p_vmspace->vm_map.pmap->pm_asid) > 0) {
+				pmap_t pmap = p->p_vmspace->vm_map.pmap;
+				pmap->pm_asid = -1;
+				__pmap_asid.hint = asid;
+				/* Invalidate all old ASID entry */
+				sh_tlb_invalidate_asid(pmap->pm_asid);
+	
+				return (__pmap_asid.hint);
+			}
 		}
 	}
 
Index: sys/arch/sparc/conf/GENERIC
===================================================================
RCS file: /cvs/OpenBSD/src/sys/arch/sparc/conf/GENERIC,v
retrieving revision 1.90
retrieving revision 1.90.8.1
diff -u -r1.90 -r1.90.8.1
--- sys/arch/sparc/conf/GENERIC	29 May 2007 09:54:03 -0000	1.90
+++ sys/arch/sparc/conf/GENERIC	18 Feb 2009 12:43:24 -0000	1.90.8.1
@@ -28,7 +28,7 @@
 # Options for SPARCstation hardware
 option		COMPAT_SUNOS	# compatibility with SunOS binaries
 option		COMPAT_SVR4	# compatibility with SVR4 binaries
-option		PROCFS		# /proc
+#option		PROCFS		# /proc
 
 option		WSEMUL_SUN	# provide sun terminal emulation; required
 option		WSEMUL_NO_VT100	# do not provide vt100 terminal emulation
Index: sys/arch/sparc64/sparc64/db_interface.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/arch/sparc64/sparc64/db_interface.c,v
retrieving revision 1.26
retrieving revision 1.26.4.3
diff -u -r1.26 -r1.26.4.3
--- sys/arch/sparc64/sparc64/db_interface.c	13 Mar 2008 23:29:46 -0000	1.26
+++ sys/arch/sparc64/sparc64/db_interface.c	18 Feb 2009 12:43:24 -0000	1.26.4.3
@@ -815,18 +815,21 @@
 	char *modif;
 {
 	struct proc *p;
+	struct inst *inst;
 
 	/* XXX LOCKING XXX */
-	LIST_FOREACH(p, &allproc, p_list) {
-		if (p->p_stat) {
-			db_printf("process %p:", p);
-			db_printf("pid:%d pmap:%p ctx:%x tf:%p fpstate %p "
-				"lastcall:%s\n",
-				p->p_pid, p->p_vmspace->vm_map.pmap,
-				p->p_vmspace->vm_map.pmap->pm_ctx,
-				p->p_md.md_tf, p->p_md.md_fpstate,
-				(p->p_addr->u_pcb.lastcall)?
-				p->p_addr->u_pcb.lastcall : "Null");
+	LIST_FOREACH(inst, &inst_all, inst_list) {
+		LIST_FOREACH(p, &inst->inst_proc->allproc, p_list) {
+			if (p->p_stat) {
+				db_printf("process %p:", p);
+				db_printf("inst:%u pid:%d pmap:%p ctx:%x tf:%p fpstate %p "
+					"lastcall:%s\n", p->p_inst->inst_id,
+					p->p_pid, p->p_vmspace->vm_map.pmap,
+					p->p_vmspace->vm_map.pmap->pm_ctx,
+					p->p_md.md_tf, p->p_md.md_fpstate,
+					(p->p_addr->u_pcb.lastcall)?
+					p->p_addr->u_pcb.lastcall : "Null");
+			}
 		}
 	}
 	return;
@@ -886,23 +889,31 @@
 	char *modif;
 {
 	struct proc *p, *pp;
+	struct inst *inst;
 
 	if (!have_addr) {
 		db_printf("What PID do you want to map in?\n");
 		return;
 	}
+	
+	/* 
+	 * FIXME: this doesn't work if multiple procs/same pids can
+	 * co-exist (mult).
+	 */
     
-	LIST_FOREACH(p, &allproc, p_list) {
-		pp = p->p_pptr;
-		if (p->p_stat && p->p_pid == addr) {
-			curproc = p;
-			curpcb = (struct pcb*)p->p_addr;
-			if (p->p_vmspace->vm_map.pmap->pm_ctx) {
-				switchtoctx(p->p_vmspace->vm_map.pmap->pm_ctx);
+	LIST_FOREACH(inst, &inst_all, inst_list) {
+		LIST_FOREACH(p, &inst->inst_proc->allproc, p_list) {
+			pp = p->p_pptr;
+			if (p->p_stat && p->p_pid == addr) {
+				curproc = p;
+				curpcb = (struct pcb*)p->p_addr;
+				if (p->p_vmspace->vm_map.pmap->pm_ctx) {
+					switchtoctx(p->p_vmspace->vm_map.pmap->pm_ctx);
+					return;
+				}
+				db_printf("PID %ld has a null context.\n", addr);
 				return;
 			}
-			db_printf("PID %ld has a null context.\n", addr);
-			return;
 		}
 	}
 	db_printf("PID %ld not found.\n", addr);
Index: sys/arch/sparc64/sparc64/db_trace.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/arch/sparc64/sparc64/db_trace.c,v
retrieving revision 1.9
retrieving revision 1.9.8.1
diff -u -r1.9 -r1.9.8.1
--- sys/arch/sparc64/sparc64/db_trace.c	15 Aug 2007 20:10:08 -0000	1.9
+++ sys/arch/sparc64/sparc64/db_trace.c	16 Sep 2008 23:10:38 -0000	1.9.8.1
@@ -79,6 +79,9 @@
 		frame = (vaddr_t)DDB_TF->tf_out[6];
 	else {
 		if (trace_thread) {
+			/* FIXME: instances */
+			(*pr)("db_trace.c: operation not supported\n");
+#if 0
 			struct proc *p;
 			struct user *u;
 			(*pr)("trace: pid %d ", (int)addr);
@@ -90,6 +93,7 @@
 			u = p->p_addr;
 			frame = (vaddr_t)u->u_pcb.pcb_sp;
 			(*pr)("at %p\n", frame);
+#endif
 		} else {
 			frame = (vaddr_t)addr;
 		}
Index: sys/arch/vax/vax/db_machdep.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/arch/vax/vax/db_machdep.c,v
retrieving revision 1.18
retrieving revision 1.18.4.1
diff -u -r1.18 -r1.18.4.1
--- sys/arch/vax/vax/db_machdep.c	30 Mar 2008 18:24:04 -0000	1.18
+++ sys/arch/vax/vax/db_machdep.c	16 Sep 2008 23:10:38 -0000	1.18.4.1
@@ -347,6 +347,9 @@
 	 * if no address then either current proc or panic
 	 */
 	if (have_addr) {
+		/* FIXME: instances */
+		(*pr) ("db_machdep.c: operation not supported\n");
+#if 0
 		p = pfind((int)addr);
 		/* Try to be helpful by looking at it as if it were decimal */
 		if (p == NULL) {
@@ -368,6 +371,7 @@
 				return;
 			}
 		}
+#endif
 	} else {
 		p = curproc;
 		if (p == NULL) {
Index: sys/compat/hpux/hpux_compat.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/compat/hpux/hpux_compat.c,v
retrieving revision 1.29
retrieving revision 1.29.6.1
diff -u -r1.29 -r1.29.6.1
--- sys/compat/hpux/hpux_compat.c	22 Sep 2007 09:57:40 -0000	1.29
+++ sys/compat/hpux/hpux_compat.c	16 Sep 2008 23:10:38 -0000	1.29.6.1
@@ -519,7 +519,7 @@
 		return (EINVAL);
 	if (SCARG(uap, pid) == 0)
 		p = cp;
-	else if ((p = pfind(SCARG(uap, pid))) == 0)
+	else if ((p = pfind(cp->p_inst->inst_proc, SCARG(uap, pid))) == 0)
 		return (ESRCH);
 	nice = p->p_nice;
 	if (nice < NZERO)
@@ -597,7 +597,7 @@
 		 * has the correct value (the child has already trapped
 		 * into the kernel).
 		 */
-		if ((cp = pfind(SCARG(uap, pid))) == 0)
+		if ((cp = pfind(p->p_inst->inst_proc, SCARG(uap, pid))) == 0)
 			return (ESRCH);
 		SCARG(uap, addr) =
 		    (int *)hpux_to_bsd_uoff(SCARG(uap, addr), &isps, cp);
@@ -961,7 +961,7 @@
 
 	if (SCARG(uap, pid) == 0)
 		SCARG(uap, pid) = cp->p_pid;
-	p = pfind(SCARG(uap, pid));
+	p = pfind(cp->p_inst->inst_proc, SCARG(uap, pid));
 	if (p == 0)
 		return (ESRCH);
 	if (cp->p_ucred->cr_uid && p->p_ucred->cr_uid != cp->p_ucred->cr_uid &&
Index: sys/compat/linux/linux_file.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/compat/linux/linux_file.c,v
retrieving revision 1.23
retrieving revision 1.23.10.2
diff -u -r1.23 -r1.23.10.2
--- sys/compat/linux/linux_file.c	25 Sep 2006 07:12:57 -0000	1.23
+++ sys/compat/linux/linux_file.c	18 Sep 2008 17:21:02 -0000	1.23.10.2
@@ -417,12 +417,12 @@
 		if ((long)arg <= 0) {
 			pgid = -(long)arg;
 		} else {
-			struct proc *p1 = pfind((long)arg);
+			struct proc *p1 = pfind(p->p_inst->inst_proc, (long)arg);
 			if (p1 == 0)
 				return (ESRCH);
 			pgid = (long)p1->p_pgrp->pg_id;
 		}
-		pgrp = pgfind(pgid);
+		pgrp = pgfind(p->p_inst->inst_proc, pgid);
 		if (pgrp == NULL || pgrp->pg_session != p->p_session)
 			return EPERM;
 		tp->t_pgrp = pgrp;
Index: sys/compat/linux/linux_misc.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/compat/linux/linux_misc.c,v
retrieving revision 1.62
retrieving revision 1.62.4.3
diff -u -r1.62 -r1.62.4.3
--- sys/compat/linux/linux_misc.c	26 Jun 2008 05:42:14 -0000	1.62
+++ sys/compat/linux/linux_misc.c	18 Feb 2009 12:43:24 -0000	1.62.4.3
@@ -1226,7 +1226,7 @@
 	struct proc *targp;
 
 	if (SCARG(uap, pid) != 0 && SCARG(uap, pid) != p->p_pid) {
-		if ((targp = pfind(SCARG(uap, pid))) == 0)
+		if ((targp = pfind(p->p_inst->inst_proc, SCARG(uap, pid))) == 0)
 			return ESRCH;
 	}
 	else
@@ -1320,7 +1320,7 @@
 		return 0;
 	}
 
-	p1 = pfind((int)pid);
+	p1 = pfind(p->p_inst->inst_proc, (int)pid);
 	if (p1 == NULL)
 		return ESRCH;
 
Index: sys/compat/linux/linux_sched.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/compat/linux/linux_sched.c,v
retrieving revision 1.6
retrieving revision 1.6.4.1
diff -u -r1.6 -r1.6.4.1
--- sys/compat/linux/linux_sched.c	26 Jun 2008 05:42:14 -0000	1.6
+++ sys/compat/linux/linux_sched.c	16 Sep 2008 23:10:38 -0000	1.6.4.1
@@ -121,7 +121,7 @@
 	if (SCARG(uap, pid) != 0) {
 		struct pcred *pc = cp->p_cred;
 
-		if ((p = pfind(SCARG(uap, pid))) == NULL)
+		if ((p = pfind(cp->p_inst->inst_proc, SCARG(uap, pid))) == NULL)
 			return (ESRCH);
 		if (!(cp == p ||
 		      pc->pc_ucred->cr_uid == 0 ||
@@ -158,7 +158,7 @@
 	if (SCARG(uap, pid) != 0) {
 		struct pcred *pc = cp->p_cred;
 
-		if ((p = pfind(SCARG(uap, pid))) == NULL)
+		if ((p = pfind(cp->p_inst->inst_proc, SCARG(uap, pid))) == NULL)
 			return (ESRCH);
 		if (!(cp == p ||
 		      pc->pc_ucred->cr_uid == 0 ||
@@ -202,7 +202,7 @@
 	if (SCARG(uap, pid) != 0) {
 		struct pcred *pc = cp->p_cred;
 
-		if ((p = pfind(SCARG(uap, pid))) == NULL)
+		if ((p = pfind(cp->p_inst->inst_proc, SCARG(uap, pid))) == NULL)
 			return (ESRCH);
 		if (!(cp == p ||
 		      pc->pc_ucred->cr_uid == 0 ||
@@ -242,7 +242,7 @@
 	if (SCARG(uap, pid) != 0) {
 		struct pcred *pc = cp->p_cred;
 
-		if ((p = pfind(SCARG(uap, pid))) == NULL)
+		if ((p = pfind(cp->p_inst->inst_proc, SCARG(uap, pid))) == NULL)
 			return (ESRCH);
 		if (!(cp == p ||
 		      pc->pc_ucred->cr_uid == 0 ||
